#include "DxLib.h"
#include "resource.h"

//-----------------------------------------------------------------------------
//	萔
//-----------------------------------------------------------------------------
#define MAP_X 7								// }bvf[^
#define MAP_Y 10
#define BLOCK_SIZE 40
#define SCREEN_X (MAP_X-2) * BLOCK_SIZE		// ͈͊Og( -2 )
#define SCREEN_Y (MAP_Y-2) * BLOCK_SIZE
#define DELNUM 3							// AƏ鐔

// ubN
enum {
	WALL = -1,	// 
	SPACE,		// 
	RED,		// 
	YELLOW,		// 
	GREEN,		// 
	AQUABLUE,	// 
	BLUE,		// 
	PINK,		// 
	WHITE,		// 
	CONTROL,	// J[\
	GRAPHNUM,	// 摜
};


//-----------------------------------------------------------------------------
//	O[oϐ
//-----------------------------------------------------------------------------
int key[256];						// L[Ăt[i[
int control_X = 0, control_Y = 0;	// pW
int delCount = 0;					// Aŏ
int animationCount = 0;				// Aj[VJE^[
int map[MAP_X][MAP_Y] = {			// zuubN
	{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
	{-1,0,3,4,2,1,2,2,5,-1},
	{-1,0,0,4,3,1,3,5,1,-1},
	{-1,4,3,5,4,1,3,1,6,-1},
	{-1,0,0,0,0,3,4,1,6,-1},
	{-1,0,0,0,6,5,4,5,5,-1},
	{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1},
};	


//-----------------------------------------------------------------------------
//	vg^Cv
//-----------------------------------------------------------------------------
int UpdateKey();									// L[̓͏ԂXV( ^ٗl )
void DrawScreen( int*, int );						// ʌvZ
void Control();										// 쏈
bool ActionMove();									// S@
bool PushMove();									// ubNl߂鏈
bool AnimationMove();								// Aj[V


/********************@
C֐@
********************/

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )
{
	// ϐ
	bool wait_f = true;				// ҋ@tO
	int draw_C = 0;					// \JE^[
	int blockimg[GRAPHNUM];			// ubN摜

	// ^Cgݒ
	SetMainWindowText( "plde" );				

	// ݒ菈
	if ( SetGraphMode( SCREEN_X, SCREEN_Y, 16 ) != DX_CHANGESCREEN_OK || DxLib_Init() == -1 ) return -1; 

	// 摜ǂݍ
	LoadDivGraphToResource ( MAKEINTRESOURCE( ID_BLOCKIMG ), "BLOCK", GRAPHNUM, 1, 9, BLOCK_SIZE, BLOCK_SIZE, blockimg );
	int fonthandle = CreateFontToHandle( "HGSnpp߯ߑ", 20, 3 );						// tHgZbg

	while ( ProcessMessage( ) == 0 && ClearDrawScreen( ) == 0 && UpdateKey( ) == 0 && key[KEY_INPUT_ESCAPE] == 0 ){
		//		 үޏ				ʂر				ްޓ͏Ԏ擾       ESCĂȂ	
		switch ( delCount ){
		case 0:
			Control();										// 쏈
			break;
		default: 
			if ( wait_f ) break;							// ꎞf 
			wait_f = AnimationMove();						// Aj[V
			if ( wait_f ) break;							// ꎞf
			wait_f = ActionMove();							// 폜
			if ( wait_f) break;								// ꎞf
			wait_f = PushMove();							// ubNl߂
			break;
		}

		if ( (draw_C % 30) == 1 ) wait_f = false;			// ĊJ
		DrawScreen( blockimg, fonthandle  );				// ʌvZ
		draw_C++;											// \JE^[
	}
	DxLib_End();											// DXCuI
	return 0;
} 


//-----------------------------------------------------------------------------
// ֐@F@gpUpdateKey()
// @\TvF@L[̓͏ԂXV(^ٗl)
//-----------------------------------------------------------------------------
int UpdateKey() 
{
	char tmpkey[256];					// ݂̃L[̓͏Ԃi[
	GetHitKeyStateAll( tmpkey );		// SẴL[̓͏Ԃ𓾂
	for ( int i = 0; i < 256; i++ ){ 
		if ( tmpkey[i] != 0 ){			// iԂ̃L[R[hɑΉL[Ă
			key[i]++;					// Z
		} else {						// ĂȂ
			key[i] = 0;					// 0ɂ
		}
	}
	return 0;
}


//-----------------------------------------------------------------------------
// ֐@F@Control()
// @\TvF@쏈
//-----------------------------------------------------------------------------
void Control()
{
	// J[\͈͓ړ( OgvZ )		
	if ( key[KEY_INPUT_UP] == 1 ){
		if ( map[control_X+1][control_Y] != WALL ){
			control_Y -= 1;
		}
	}
	if ( key[KEY_INPUT_DOWN] == 1 ){
		if ( map[control_X+1][control_Y+2] != WALL ){
			control_Y += 1;
		}
	}
	if ( key[KEY_INPUT_LEFT] == 1 ){
		if ( map[control_X][control_Y+1] != WALL ){
			control_X -= 1;
		}
	}
	if ( key[KEY_INPUT_RIGHT] == 1 ){
		if ( map[control_X+3][control_Y+1] != WALL ){
			control_X += 1;
		}
	}	
	// 菈		
	if ( key[KEY_INPUT_SPACE] == 1 ){
		ActionMove();
	}
}


//-----------------------------------------------------------------------------
// ֐@F@DrawScreen()
// @\TvF@Q[Cʕ`揈
//-----------------------------------------------------------------------------
void DrawScreen( int* blockimg, int handle_f )
{
	// f[^ɉ}bvS̕\
	for ( int loop_Y = 0; loop_Y < MAP_Y; loop_Y++ ){					
		for ( int loop_X = 0; loop_X < MAP_X; loop_X++ ){			
			switch ( map[loop_X+1][loop_Y+1] ){
			case WALL:																			// 														
				break;
			case SPACE:
				DrawGraph( BLOCK_SIZE*loop_X, BLOCK_SIZE*loop_Y, blockimg[SPACE], FALSE );		// ubN
				break;
			case RED:
				DrawGraph( BLOCK_SIZE*loop_X, BLOCK_SIZE*loop_Y, blockimg[RED], FALSE );		// 
				break;
			case YELLOW:
				DrawGraph( BLOCK_SIZE*loop_X, BLOCK_SIZE*loop_Y, blockimg[YELLOW], FALSE );		// @
				break;
			case GREEN:
				DrawGraph( BLOCK_SIZE*loop_X, BLOCK_SIZE*loop_Y, blockimg[GREEN], FALSE );		// 
				break;
			case AQUABLUE:
				DrawGraph( BLOCK_SIZE*loop_X, BLOCK_SIZE*loop_Y, blockimg[AQUABLUE], FALSE );	// @
				break;
			case BLUE:
				DrawGraph( BLOCK_SIZE*loop_X, BLOCK_SIZE*loop_Y, blockimg[BLUE], FALSE );		// @
				break;
			case PINK:
				DrawGraph( BLOCK_SIZE*loop_X, BLOCK_SIZE*loop_Y, blockimg[PINK], FALSE );		// @
				break;
			case WHITE:
				DrawGraph( BLOCK_SIZE*loop_X, BLOCK_SIZE*loop_Y, blockimg[WHITE], FALSE );		// @
				break;
			case 10:
				// 鏇ԕ\
				DrawGraph( BLOCK_SIZE*loop_X, BLOCK_SIZE*loop_Y, blockimg[SPACE], FALSE );	
				DrawString( BLOCK_SIZE*loop_X+BLOCK_SIZE/4, BLOCK_SIZE*loop_Y+BLOCK_SIZE/4, "P",  GetColor(255,0,0) );
				break;
			case 20:
				DrawGraph( BLOCK_SIZE*loop_X, BLOCK_SIZE*loop_Y, blockimg[SPACE], FALSE );	
				DrawString( BLOCK_SIZE*loop_X+BLOCK_SIZE/4, BLOCK_SIZE*loop_Y+BLOCK_SIZE/4, "Q",  GetColor(255,0,0) );
				break;
			case 30:
				DrawGraph( BLOCK_SIZE*loop_X, BLOCK_SIZE*loop_Y, blockimg[SPACE], FALSE );	
				DrawString( BLOCK_SIZE*loop_X+BLOCK_SIZE/4, BLOCK_SIZE*loop_Y+BLOCK_SIZE/4, "R",  GetColor(255,0,0) );
				break;
			}
		}
	}

	// PӏĂȂꍇ
	if ( !delCount ){
		// IJ[\\
		DrawGraph( BLOCK_SIZE*control_X, BLOCK_SIZE*control_Y, blockimg[CONTROL], TRUE );	
		DrawGraph( BLOCK_SIZE*(control_X+1), BLOCK_SIZE*control_Y, blockimg[CONTROL], TRUE );
	} else if ( delCount != 10 ){
		// Aɉ\
		for ( int strlen = 1;  strlen <= delCount; strlen++ ){
			DrawFormatStringToHandle( 0, 0, GetColor(255,0,0), handle_f, "%dA", delCount );
		}
	} else {
		// 萔ɒBꍇ
		for ( int strlen = 1;  strlen <= delCount; strlen++ ){
			// DrawFormatStringToHandle( 0, 0, GetColor(255,0,0), handle_f, "%dA", delCount );
			 DrawFormatStringToHandle( (SCREEN_X/2)-(9*5), SCREEN_Y/2, GetColor(GetRand(255),GetRand(255),GetRand(255)), handle_f, "PERFECT!!" );	// \̈ו*TCY
		}
	}
	ScreenFlip();										// ʃf[^\ʂ֔f
}


//-----------------------------------------------------------------------------
// ֐@F@ActionMove()
// @\TvF@莞
//-----------------------------------------------------------------------------
bool ActionMove()
{
	bool wait_f = false;										// ꎞҋ@tO
	int temp;													// ̍ۈꎞۑ
	int del_CountX = 0, del_CountY = 0;							// 폜tOc						
	int delLine_X[(MAP_X-2)/DELNUM*(MAP_Y-2)*2] = {0};			// 폜Cۑ( őQ )
	int delLine_Y[(MAP_Y-2)/DELNUM*(MAP_X-2)*2] = {0};			
	int delLine_XC = 0, delLine_YC = 0;							// 폜CpY

	// 
	if ( !delCount ){		
		temp = map[control_X+1][control_Y+1];
		map[control_X+1][control_Y+1] = map[control_X+2][control_Y+1];
		map[control_X+2][control_Y+1] = temp;
	}

	// J[ő吔܂( ubN )
	for ( int loop_colorNum =  1; loop_colorNum < CONTROL; loop_colorNum++ ){	
		for ( int loop_Y = 1; loop_Y < MAP_Y; loop_Y++ ){		// ͈͓
			for ( int loop_X = 1; loop_X < MAP_X; loop_X++ ){	// 
				if ( map[loop_X][loop_Y]  == loop_colorNum ){	
					del_CountX++;
					// 鐔ɒB۔
					if ( del_CountX == DELNUM ){
						delLine_X[delLine_XC] = loop_X ;
						delLine_X[delLine_XC+1] = loop_Y;
						del_CountX = 0;
						delLine_XC += 2;
					}
				} else {
					del_CountX = 0;					// AĂȂ
				}
			}
			del_CountX = 0;							// ύX
		}
		del_CountX = 0;								// ubNύX
	}

	// J[ő吔܂( cubN )
	for ( int loop_colorNum =  1; loop_colorNum < CONTROL; loop_colorNum++ ){
		for ( int loop_X = 1; loop_X < MAP_X; loop_X++ ){
			for ( int loop_Y = 1; loop_Y < MAP_Y; loop_Y++ ){
				if ( map[loop_X][loop_Y]  == loop_colorNum ){
					del_CountY++;
					// 鐔ɒB۔
					if ( del_CountY == DELNUM ){
						delLine_Y[delLine_YC] = loop_X;
						delLine_Y[delLine_YC+1] = loop_Y;
						del_CountY = 0;
						delLine_YC += 2;
					}
				} else {
					del_CountY = 0;					// AĂȂ
				}
			}
			del_CountY = 0;							// ύX
		}
		del_CountY = 0;								// ubNύX
	}

	// 
	if ( delLine_XC || delLine_YC ){
		animationCount = 4;
		// 
		for (delLine_XC -= 1; delLine_XC > 0; delLine_XC -= 2 ){
			map[delLine_X[delLine_XC-1]][delLine_X[delLine_XC]] = 10;
			map[delLine_X[delLine_XC-1]-1][delLine_X[delLine_XC]] = 20;
			map[delLine_X[delLine_XC-1]-2][delLine_X[delLine_XC]] = 30;
		} 
		// c
		for (delLine_YC -= 1; delLine_YC > 0; delLine_YC -= 2 ){
			map[delLine_Y[delLine_YC-1]][delLine_Y[delLine_YC]] = 10;
			map[delLine_Y[delLine_YC-1]][delLine_Y[delLine_YC]-1] = 20;
			map[delLine_Y[delLine_YC-1]][delLine_Y[delLine_YC]-2] = 30;
		} 
		delCount++;
		wait_f = true;
	}
	return wait_f;
}


//-----------------------------------------------------------------------------
// ֐@F@PushMove()
// @\TvF@ubNl߂鏈
//-----------------------------------------------------------------------------
bool PushMove()
{
	int temp[MAP_Y];										// ̍ۈꎞۑ	
	int block_C = 0;										// ݃ubN		

	// Xy[X
	for ( int loop_X = 1; loop_X < MAP_X; loop_X++ ){
		for ( int loop_Y = 1; loop_Y < MAP_Y; loop_Y++ ){
			if ( map[loop_X][loop_Y] > SPACE ){				// ݂ubN
				temp[block_C] = map[loop_X][loop_Y];		// ꎞۑ
				map[loop_X][loop_Y] = 0;					
				block_C++;									
			}
		}
		// iɋl߂Ĕzu
		for ( int temp_C = 0; block_C; temp_C++, --block_C ){	
			map[loop_X][MAP_Y-block_C-1] = temp[temp_C];
		}
	}
	return true;
}


//-----------------------------------------------------------------------------
// ֐@F@AnimationMove()
// @\TvF@Aj[V
//-----------------------------------------------------------------------------
bool AnimationMove()
{
	// Aj[VubN
	for ( int loop_Y = 1; loop_Y < MAP_Y; loop_Y++ ){
		for ( int loop_X = 1; loop_X < MAP_X; loop_X++ ){
			switch ( map[loop_X][loop_Y] ){
			case 10:
				map[loop_X][loop_Y] = 0;
				break;
			case 20:
				map[loop_X][loop_Y] = 10;
				break;
			case 30:
				map[loop_X][loop_Y] = 20;
				break;
			}
		}
	}
	if ( animationCount ) animationCount--;
	return   animationCount > 0;
}